/* Lying. */
typedef int PyObject;
typedef int PyArrayObject;
typedef long maybelong;
typedef signed char int8_t;
typedef unsigned char uint8_t;
typedef signed short int16_t;
typedef unsigned short uint16_t;
typedef long int32_t;
typedef unsigned long uint32_t;
typedef long long int64_t;
typedef unsigned long long uint64_t;
typedef int PyMethodDef;

/* This code was machine generated using expandcast.py and Cast.template. */
/*
#include </usr/local/include/python2.3/Python.h>
#include "/usr/local/include/python2.3/numarray/libnumarray.h"
#include <limits.h>
#include <float.h>
#include <inttypes.h>
*/
/* For floating point types there is a subtlety. Some of the larger integer
   limits cannot be written exactly in floating point. Therefore casting is
   done by "clip" only for inlo < x < inhi. No casting is done for the
   limits.
*/
/*
#define clip(x, inlo, inhi, outlo, outhi, typeout) (((x) <= (inlo)) ? (outlo) :    ((x) >= (inhi)) ? (outhi) : (typeout)(x))
*/
#define clip(x, inlo, inhi, outlo, outhi, typeout) 777;

static int iseasycast(long intypeno, long outtypeno);
static PyObject* ClippingCast(PyObject* arrin, long outtypeno);
static PyObject* CCast(PyObject* arrin, long outtypeno);
static PyObject* BoolCast(PyObject* arrin, long outtypeno);
static PyObject* AnyClipCast(PyObject* arrin, long outtypeno);



static int iseasycast(long intypeno, long outtypeno)
{
    int c1, c2, c3, c4;

    if (intypeno == outtypeno)
        return 1;
    if (intypeno == tBool || outtypeno == tBool)
        return 0;
    c1 = (intypeno <= outtypeno);
    c2 = (intypeno == tInt64 && outtypeno == tFloat32);
    c3 = (intypeno == tInt8 || intypeno == tInt16 ||
          intypeno == tInt32 || intypeno == tInt64);
    c4 = (outtypeno == tUInt8 || outtypeno == tUInt16 ||
          outtypeno == tUInt32 || outtypeno == tUInt64);
    return c1 && !c2 && !(c2 && c3);
}


static PyObject* ClippingCast(PyObject* arrin, long outtypeno)
{
    PyArrayObject* paoarrin = (PyArrayObject*) arrin;
    PyObject* arrout = NULL;
    PyArrayObject* paoarrout = NULL;
    PyArrayObject* temparr = NULL;
    long elements, i, intypeno;
    void * tempdata = NULL;
    void * arroutdata = NULL;

    intypeno = paoarrin->descr->type_num;

    if (intypeno == tBool || outtypeno == tBool) {
        PyErr_SetString(PyExc_TypeError, "Bool type not allowed for either input or output");
        return NULL;
    }

    temparr = NA_InputArray(arrin, intypeno, NUM_C_ARRAY);
    if (temparr == NULL) return NULL;
    elements = NA_elements(temparr);
    tempdata = NA_OFFSETDATA(temparr);

    arrout = (PyObject*) NA_vNewArray(NULL, outtypeno, temparr->nd,
               (maybelong*) temparr->dimensions);
    if (arrout == NULL) {
        Py_DECREF(temparr);
        return NULL;
    }
    paoarrout = (PyArrayObject*) arrout;
    arroutdata = NA_OFFSETDATA(paoarrout);
    switch (1000*intypeno + outtypeno) {
        case 2002: {
            signed char * datain = (signed char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 2003: {
            signed char * datain = (signed char*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) 0), ((int8_t) (127)), ((uint8_t) 0), ((uint8_t) (127)), unsigned char);
            }
            break;
        }
        case 2004: {
            signed char * datain = (signed char*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((int16_t) (-128)), ((int16_t) (127)), short);
            }
            break;
        }
        case 2005: {
            signed char * datain = (signed char*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) 0), ((int8_t) (127)), ((uint16_t) 0), ((uint16_t) (127)), unsigned short);
            }
            break;
        }
        case 2006: {
            signed char * datain = (signed char*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((int32_t) (-128)), ((int32_t) (127)), int);
            }
            break;
        }
        case 2007: {
            signed char * datain = (signed char*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) 0), ((int8_t) (127)), ((uint32_t) 0), ((uint32_t) (127)), unsigned int);
            }
            break;
        }
        case 2008: {
            signed char * datain = (signed char*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((int64_t) (-128)), ((int64_t) (127)), signed long long int);
            }
            break;
        }
        case 2009: {
            signed char * datain = (signed char*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) 0), ((int8_t) (127)), ((uint64_t) 0), ((uint64_t) (127)), unsigned long long int);
            }
            break;
        }
        case 2010: {
            signed char * datain = (signed char*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((float) (-0x1p+7)), ((float) (0x1.fc00000000000p+6)), float);
            }
            break;
        }
        case 2011: {
            signed char * datain = (signed char*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int8_t) (-128)), ((int8_t) (127)), ((double) (-0x1p+7)), ((double) (0x1.fc00000000000p+6)), double);
            }
            break;
        }
        case 3002: {
            unsigned char * datain = (unsigned char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (127)), ((int8_t) 0), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 3003: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 3004: {
            unsigned char * datain = (unsigned char*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((int16_t) 0), ((int16_t) (255)), short);
            }
            break;
        }
        case 3005: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((uint16_t) 0), ((uint16_t) (255)), unsigned short);
            }
            break;
        }
        case 3006: {
            unsigned char * datain = (unsigned char*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((int32_t) 0), ((int32_t) (255)), int);
            }
            break;
        }
        case 3007: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((uint32_t) 0), ((uint32_t) (255)), unsigned int);
            }
            break;
        }
        case 3008: {
            unsigned char * datain = (unsigned char*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((int64_t) 0), ((int64_t) (255)), signed long long int);
            }
            break;
        }
        case 3009: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((uint64_t) 0), ((uint64_t) (255)), unsigned long long int);
            }
            break;
        }
        case 3010: {
            unsigned char * datain = (unsigned char*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((float) (0x0p+0)), ((float) (0x1.fe00000000000p+7)), float);
            }
            break;
        }
        case 3011: {
            unsigned char * datain = (unsigned char*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint8_t) 0), ((uint8_t) (255)), ((double) (0x0p+0)), ((double) (0x1.fe00000000000p+7)), double);
            }
            break;
        }
        case 4002: {
            short * datain = (short*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-128)), ((int16_t) (127)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 4003: {
            short * datain = (short*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) 0), ((int16_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 4004: {
            short * datain = (short*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-32767-1)), ((int16_t) (32767)), ((int16_t) (-32767-1)), ((int16_t) (32767)), short);
            }
            break;
        }
        case 4005: {
            short * datain = (short*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) 0), ((int16_t) (32767)), ((uint16_t) 0), ((uint16_t) (32767)), unsigned short);
            }
            break;
        }
        case 4006: {
            short * datain = (short*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-32767-1)), ((int16_t) (32767)), ((int32_t) (-32767-1)), ((int32_t) (32767)), int);
            }
            break;
        }
        case 4007: {
            short * datain = (short*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) 0), ((int16_t) (32767)), ((uint32_t) 0), ((uint32_t) (32767)), unsigned int);
            }
            break;
        }
        case 4008: {
            short * datain = (short*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-32767-1)), ((int16_t) (32767)), ((int64_t) (-32767-1)), ((int64_t) (32767)), signed long long int);
            }
            break;
        }
        case 4009: {
            short * datain = (short*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) 0), ((int16_t) (32767)), ((uint64_t) 0), ((uint64_t) (32767)), unsigned long long int);
            }
            break;
        }
        case 4010: {
            short * datain = (short*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-32767-1)), ((int16_t) (32767)), ((float) (-0x1p+15)), ((float) (0x1.fffc000000000p+14)), float);
            }
            break;
        }
        case 4011: {
            short * datain = (short*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int16_t) (-32767-1)), ((int16_t) (32767)), ((double) (-0x1p+15)), ((double) (0x1.fffc000000000p+14)), double);
            }
            break;
        }
        case 5002: {
            unsigned short * datain = (unsigned short*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (127)), ((int8_t) 0), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 5003: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 5004: {
            unsigned short * datain = (unsigned short*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (32767)), ((int16_t) 0), ((int16_t) (32767)), short);
            }
            break;
        }
        case 5005: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 5006: {
            unsigned short * datain = (unsigned short*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((int32_t) 0), ((int32_t) (65535)), int);
            }
            break;
        }
        case 5007: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((uint32_t) 0), ((uint32_t) (65535)), unsigned int);
            }
            break;
        }
        case 5008: {
            unsigned short * datain = (unsigned short*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((int64_t) 0), ((int64_t) (65535)), signed long long int);
            }
            break;
        }
        case 5009: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((uint64_t) 0), ((uint64_t) (65535)), unsigned long long int);
            }
            break;
        }
        case 5010: {
            unsigned short * datain = (unsigned short*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((float) (0x0p+0)), ((float) (0x1.fffe000000000p+15)), float);
            }
            break;
        }
        case 5011: {
            unsigned short * datain = (unsigned short*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint16_t) 0), ((uint16_t) (65535)), ((double) (0x0p+0)), ((double) (0x1.fffe000000000p+15)), double);
            }
            break;
        }
        case 6002: {
            int * datain = (int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-128)), ((int32_t) (127)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 6003: {
            int * datain = (int*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) 0), ((int32_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 6004: {
            int * datain = (int*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-32767-1)), ((int32_t) (32767)), ((int16_t) (-32767-1)), ((int16_t) (32767)), short);
            }
            break;
        }
        case 6005: {
            int * datain = (int*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) 0), ((int32_t) (65535)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 6006: {
            int * datain = (int*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 6007: {
            int * datain = (int*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) 0), ((int32_t) (2147483647)), ((uint32_t) 0), ((uint32_t) (2147483647)), unsigned int);
            }
            break;
        }
        case 6008: {
            int * datain = (int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), ((int64_t) (-2147483647-1)), ((int64_t) (2147483647)), signed long long int);
            }
            break;
        }
        case 6009: {
            int * datain = (int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) 0), ((int32_t) (2147483647)), ((uint64_t) 0), ((uint64_t) (2147483647)), unsigned long long int);
            }
            break;
        }
        case 6010: {
            int * datain = (int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), ((float) (-0x1p+31)), ((float) (0x1p+31)), float);
            }
            break;
        }
        case 6011: {
            int * datain = (int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), ((double) (-0x1p+31)), ((double) (0x1.fffffffc00000p+30)), double);
            }
            break;
        }
        case 7002: {
            unsigned int * datain = (unsigned int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (127)), ((int8_t) 0), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 7003: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 7004: {
            unsigned int * datain = (unsigned int*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (32767)), ((int16_t) 0), ((int16_t) (32767)), short);
            }
            break;
        }
        case 7005: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (65535)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 7006: {
            unsigned int * datain = (unsigned int*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (2147483647)), ((int32_t) 0), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 7007: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (4294967295U)), ((uint32_t) 0), ((uint32_t) (4294967295U)), unsigned int);
            }
            break;
        }
        case 7008: {
            unsigned int * datain = (unsigned int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (4294967295U)), ((int64_t) 0), ((int64_t) (4294967295U)), signed long long int);
            }
            break;
        }
        case 7009: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (4294967295U)), ((uint64_t) 0), ((uint64_t) (4294967295U)), unsigned long long int);
            }
            break;
        }
        case 7010: {
            unsigned int * datain = (unsigned int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (4294967295U)), ((float) (0x0p+0)), ((float) (0x1p+32)), float);
            }
            break;
        }
        case 7011: {
            unsigned int * datain = (unsigned int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint32_t) 0), ((uint32_t) (4294967295U)), ((double) (0x0p+0)), ((double) (0x1.fffffffe00000p+31)), double);
            }
            break;
        }
        case 8002: {
            signed long long int * datain = (signed long long int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-128)), ((int64_t) (127)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 8003: {
            signed long long int * datain = (signed long long int*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) 0), ((int64_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 8004: {
            signed long long int * datain = (signed long long int*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-32767-1)), ((int64_t) (32767)), ((int16_t) (-32767-1)), ((int16_t) (32767)), short);
            }
            break;
        }
        case 8005: {
            signed long long int * datain = (signed long long int*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) 0), ((int64_t) (65535)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 8006: {
            signed long long int * datain = (signed long long int*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-2147483647-1)), ((int64_t) (2147483647)), ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 8007: {
            signed long long int * datain = (signed long long int*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) 0), ((int64_t) (4294967295U)), ((uint32_t) 0), ((uint32_t) (4294967295U)), unsigned int);
            }
            break;
        }
        case 8008: {
            signed long long int * datain = (signed long long int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), signed long long int);
            }
            break;
        }
        case 8009: {
            signed long long int * datain = (signed long long int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) 0), ((int64_t) (9223372036854775807LL)), ((uint64_t) 0), ((uint64_t) (9223372036854775807LL)), unsigned long long int);
            }
            break;
        }
        case 8010: {
            signed long long int * datain = (signed long long int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), ((float) (-0x1p+63)), ((float) (0x1p+63)), float);
            }
            break;
        }
        case 8011: {
            signed long long int * datain = (signed long long int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), ((double) (-0x1p+63)), ((double) (0x1p+63)), double);
            }
            break;
        }
        case 9002: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (127)), ((int8_t) 0), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 9003: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (255)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 9004: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (32767)), ((int16_t) 0), ((int16_t) (32767)), short);
            }
            break;
        }
        case 9005: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (65535)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 9006: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (2147483647)), ((int32_t) 0), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 9007: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (4294967295U)), ((uint32_t) 0), ((uint32_t) (4294967295U)), unsigned int);
            }
            break;
        }
        case 9008: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (9223372036854775807LL)), ((int64_t) 0), ((int64_t) (9223372036854775807LL)), signed long long int);
            }
            break;
        }
        case 9009: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), unsigned long long int);
            }
            break;
        }
        case 9010: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), ((float) (0x0p+0)), ((float) (0x1p+64)), float);
            }
            break;
        }
        case 9011: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), ((double) (0x0p+0)), ((double) (0x1p+64)), double);
            }
            break;
        }
        case 10002: {
            float * datain = (float*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1p+7)), ((float) (0x1.fc00000000000p+6)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 10003: {
            float * datain = (float*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (0x0p+0)), ((float) (0x1.fe00000000000p+7)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 10004: {
            float * datain = (float*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1p+15)), ((float) (0x1.fffc000000000p+14)), ((int16_t) (-32767-1)), ((int16_t) (32767)), short);
            }
            break;
        }
        case 10005: {
            float * datain = (float*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (0x0p+0)), ((float) (0x1.fffe000000000p+15)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 10006: {
            float * datain = (float*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1p+31)), ((float) (0x1p+31)), ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 10007: {
            float * datain = (float*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (0x0p+0)), ((float) (0x1p+32)), ((uint32_t) 0), ((uint32_t) (4294967295U)), unsigned int);
            }
            break;
        }
        case 10008: {
            float * datain = (float*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1p+63)), ((float) (0x1p+63)), ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), signed long long int);
            }
            break;
        }
        case 10009: {
            float * datain = (float*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (0x0p+0)), ((float) (0x1p+64)), ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), unsigned long long int);
            }
            break;
        }
        case 10010: {
            float * datain = (float*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1.fffffe0000000p+127)), ((float) (0x1.fffffe0000000p+127)), ((float) (-0x1.fffffe0000000p+127)), ((float) (0x1.fffffe0000000p+127)), float);
            }
            break;
        }
        case 10011: {
            float * datain = (float*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((float) (-0x1.fffffe0000000p+127)), ((float) (0x1.fffffe0000000p+127)), ((double) (-0x1.fffffe0000000p+127)), ((double) (0x1.fffffe0000000p+127)), double);
            }
            break;
        }
        case 11002: {
            double * datain = (double*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1p+7)), ((double) (0x1.fc00000000000p+6)), ((int8_t) (-128)), ((int8_t) (127)), signed char);
            }
            break;
        }
        case 11003: {
            double * datain = (double*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (0x0p+0)), ((double) (0x1.fe00000000000p+7)), ((uint8_t) 0), ((uint8_t) (255)), unsigned char);
            }
            break;
        }
        case 11004: {
            double * datain = (double*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1p+15)), ((double) (0x1.fffc000000000p+14)), ((int16_t) (-32767-1)), ((int16_t) (32767)), short);
            }
            break;
        }
        case 11005: {
            double * datain = (double*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (0x0p+0)), ((double) (0x1.fffe000000000p+15)), ((uint16_t) 0), ((uint16_t) (65535)), unsigned short);
            }
            break;
        }
        case 11006: {
            double * datain = (double*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1p+31)), ((double) (0x1.fffffffc00000p+30)), ((int32_t) (-2147483647-1)), ((int32_t) (2147483647)), int);
            }
            break;
        }
        case 11007: {
            double * datain = (double*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (0x0p+0)), ((double) (0x1.fffffffe00000p+31)), ((uint32_t) 0), ((uint32_t) (4294967295U)), unsigned int);
            }
            break;
        }
        case 11008: {
            double * datain = (double*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1p+63)), ((double) (0x1p+63)), ((int64_t) (-9223372036854775807LL -1)), ((int64_t) (9223372036854775807LL)), signed long long int);
            }
            break;
        }
        case 11009: {
            double * datain = (double*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (0x0p+0)), ((double) (0x1p+64)), ((uint64_t) 0), ((uint64_t) (18446744073709551615ULL)), unsigned long long int);
            }
            break;
        }
        case 11010: {
            double * datain = (double*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1.fffffe0000000p+127)), ((double) (0x1.fffffe0000000p+127)), ((float) (-0x1.fffffe0000000p+127)), ((float) (0x1.fffffe0000000p+127)), float);
            }
            break;
        }
        case 11011: {
            double * datain = (double*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++) {
                dataout[i] =
                     clip(datain[i], ((double) (-0x1.fffffffffffffp+1023)), ((double) (0x1.fffffffffffffp+1023)), ((double) (-0x1.fffffffffffffp+1023)), ((double) (0x1.fffffffffffffp+1023)), double);
            }
            break;
        }

    }
    Py_DECREF(temparr);
    return arrout;
}


static PyObject* CCast(PyObject* arrin, long outtypeno)
{
    PyArrayObject* paoarrin = (PyArrayObject*) arrin;
    PyObject* arrout = NULL;
    PyArrayObject* paoarrout = NULL;
    PyArrayObject* temparr = NULL;
    long elements, i, intypeno;
    void * tempdata = NULL;
    void * arroutdata = NULL;

    intypeno = paoarrin->descr->type_num;

    if (!iseasycast(intypeno, outtypeno)) {
        PyErr_SetString(PyExc_TypeError, "do not use \"CCast\" for this "
              "combination of types");
        return NULL;
    }

    temparr = NA_InputArray(arrin, intypeno, NUM_C_ARRAY);
    if (temparr == NULL) return NULL;
    elements = NA_elements(temparr);
    tempdata = NA_OFFSETDATA(temparr);

    arrout = (PyObject*) NA_vNewArray(NULL, outtypeno, temparr->nd,
               (maybelong*) temparr->dimensions);
    if (arrout == NULL) {
        Py_DECREF(temparr);
        return NULL;
    }
    paoarrout = (PyArrayObject*) arrout;
    arroutdata = NA_OFFSETDATA(paoarrout);
    switch (1000*intypeno + outtypeno) {

        case 2002: {
            signed char * datain = (signed char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 2004: {
            signed char * datain = (signed char*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 2006: {
            signed char * datain = (signed char*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 2008: {
            signed char * datain = (signed char*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 2010: {
            signed char * datain = (signed char*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 2011: {
            signed char * datain = (signed char*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3003: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3004: {
            unsigned char * datain = (unsigned char*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3005: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3006: {
            unsigned char * datain = (unsigned char*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3007: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3008: {
            unsigned char * datain = (unsigned char*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3009: {
            unsigned char * datain = (unsigned char*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3010: {
            unsigned char * datain = (unsigned char*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 3011: {
            unsigned char * datain = (unsigned char*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 4004: {
            short * datain = (short*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 4006: {
            short * datain = (short*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 4008: {
            short * datain = (short*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 4010: {
            short * datain = (short*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 4011: {
            short * datain = (short*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5005: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5006: {
            unsigned short * datain = (unsigned short*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5007: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5008: {
            unsigned short * datain = (unsigned short*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5009: {
            unsigned short * datain = (unsigned short*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5010: {
            unsigned short * datain = (unsigned short*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 5011: {
            unsigned short * datain = (unsigned short*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 6006: {
            int * datain = (int*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 6008: {
            int * datain = (int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 6010: {
            int * datain = (int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 6011: {
            int * datain = (int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 7007: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 7008: {
            unsigned int * datain = (unsigned int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 7009: {
            unsigned int * datain = (unsigned int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 7010: {
            unsigned int * datain = (unsigned int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 7011: {
            unsigned int * datain = (unsigned int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 8008: {
            signed long long int * datain = (signed long long int*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 8010: {
            signed long long int * datain = (signed long long int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 8011: {
            signed long long int * datain = (signed long long int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 9009: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 9010: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 9011: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 10010: {
            float * datain = (float*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 10011: {
            float * datain = (float*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }
        case 11011: {
            double * datain = (double*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = datain[i];
            break;
        }

    }
    Py_DECREF(temparr);
    return arrout;
}


static PyObject* BoolCast(PyObject* arrin, long outtypeno)
{
    PyArrayObject* paoarrin = (PyArrayObject*) arrin;
    PyObject* arrout = NULL;
    PyArrayObject* paoarrout = NULL;
    PyArrayObject* temparr = NULL;
    long elements, i, intypeno;
    void * tempdata = NULL;
    void * arroutdata = NULL;

    intypeno = paoarrin->descr->type_num;

    if (intypeno != tBool && outtypeno != tBool) {
        PyErr_SetString(PyExc_TypeError, "use \"BoolCast\" only if the input"
              " or the output is Bool");
        return NULL;
    }

    temparr = NA_InputArray(arrin, intypeno, NUM_C_ARRAY);
    if (temparr == NULL) return NULL;
    elements = NA_elements(temparr);
    tempdata = NA_OFFSETDATA(temparr);

    arrout = (PyObject*) NA_vNewArray(NULL, outtypeno, temparr->nd,
               (maybelong*) temparr->dimensions);
    if (arrout == NULL) {
        Py_DECREF(temparr);
        return NULL;
    }
    paoarrout = (PyArrayObject*) arrout;
    arroutdata = NA_OFFSETDATA(paoarrout);
    switch (1000*intypeno + outtypeno) {

        case 1001: {
            signed char * datain = (signed char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1002: {
            signed char * datain = (signed char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1003: {
            signed char * datain = (signed char*) tempdata;
            unsigned char * dataout = (unsigned char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1004: {
            signed char * datain = (signed char*) tempdata;
            short * dataout = (short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1005: {
            signed char * datain = (signed char*) tempdata;
            unsigned short * dataout = (unsigned short*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1006: {
            signed char * datain = (signed char*) tempdata;
            int * dataout = (int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1007: {
            signed char * datain = (signed char*) tempdata;
            unsigned int * dataout = (unsigned int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1008: {
            signed char * datain = (signed char*) tempdata;
            signed long long int * dataout = (signed long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1009: {
            signed char * datain = (signed char*) tempdata;
            unsigned long long int * dataout = (unsigned long long int*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1010: {
            signed char * datain = (signed char*) tempdata;
            float * dataout = (float*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 1011: {
            signed char * datain = (signed char*) tempdata;
            double * dataout = (double*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 2001: {
            signed char * datain = (signed char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 3001: {
            unsigned char * datain = (unsigned char*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 4001: {
            short * datain = (short*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 5001: {
            unsigned short * datain = (unsigned short*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 6001: {
            int * datain = (int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 7001: {
            unsigned int * datain = (unsigned int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 8001: {
            signed long long int * datain = (signed long long int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 9001: {
            unsigned long long int * datain = (unsigned long long int*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 10001: {
            float * datain = (float*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }
        case 11001: {
            double * datain = (double*) tempdata;
            signed char * dataout = (signed char*) arroutdata;
            for (i=0; i<elements; i++)
                dataout[i] = (datain[i] != 0);
            break;
        }

    }
    Py_DECREF(temparr);
    return arrout;
}


static PyObject* AnyClipCast(PyObject* arrin, long outtypeno)
{
    PyArrayObject* paoarrin = (PyArrayObject*) arrin;
    long intypeno;

    intypeno = paoarrin->descr->type_num;
    if (intypeno == tBool || outtypeno == tBool)
        return BoolCast(arrin, outtypeno);
    if (iseasycast(intypeno, outtypeno))
        return CCast(arrin, outtypeno);
    return ClippingCast(arrin, outtypeno);
}


static PyObject* IsEasyCast(PyObject* obj, PyObject *args)
{
    PyObject* itype = NULL;
    PyObject* otype = NULL;
    PyObject* intype = NULL;
    PyObject* outtype = NULL;
    long intypeno, outtypeno, answer;

    if (!PyArg_ParseTuple(args, "OO|IsEasyCast", &itype, &otype))
        return NULL;

    intype = NA_getType(itype);
    if (intype == NULL) return NULL;
    intypeno = NA_typeObjectToTypeNo(intype);

    outtype = NA_getType(otype);
    if (outtype == NULL) {
        Py_DECREF(intype);
        return NULL;
    }
    outtypeno = NA_typeObjectToTypeNo(outtype);

    Py_DECREF(outtype);
    Py_DECREF(intype);
    answer = iseasycast(intypeno, outtypeno);
    return PyInt_FromLong(answer);
}

static PyObject* Cast(PyObject* obj, PyObject *args)
{
    PyObject* otype = NULL;
    PyObject* outtype = NULL;
    PyObject* arrin = NULL;
    PyObject* arrout = NULL;
    long outtypeno;

    if (!PyArg_ParseTuple(args, "OO|Cast", &arrin, &otype))
        return NULL;

    outtype = NA_getType(otype);
    if (outtype == NULL) return NULL;
    outtypeno = NA_typeObjectToTypeNo(outtype);

    arrout = AnyClipCast(arrin, outtypeno);

    Py_DECREF(outtype);
    return arrout;
}

static PyMethodDef CastMethods[] = {
    {"IsEasyCast", IsEasyCast, METH_VARARGS},
    {"Cast", Cast, METH_VARARGS},
    {NULL,     NULL}   /* sentinel */
};

void initCast(void)
{
    (void) Py_InitModule("Cast", CastMethods);
    import_libnumarray();
}
