#define CV_MAX_DIM 40

typedef unsigned int size_t;
typedef unsigned char uchar;
typedef void CvArr;
typedef struct _IplImage {
    int  nSize;
    struct _IplROI *roi;
    char* imageData;
} IplImage;

typedef struct _IplROI {
    int  width;
    int  height;
} IplROI;

typedef struct CvMat
{
    int type;
    int step;
    int* refcount;

    union
    {
        uchar* ptr;
        double* db;
    } data;

    int rows;
    int cols;
} CvMat;

CvMat cvMat( int rows, int cols, int type, void* data );
double  cvmGet( const CvMat* mat, int i, int j );
void  cvmSet( CvMat* mat, int i, int j, double val );

typedef struct CvMatND
{
    int type;
    int dims;

    int* refcount;
    union
    {
        uchar* ptr;
        double* db;
    } data;

    struct
    {
        int size;
        int step;
    }
    dim[CV_MAX_DIM];
} CvMatND;

typedef struct CvPoint
{
    int x;
    int y;
}
CvPoint;

CvPoint  cvPoint( int x, int y );

typedef enum CvDisType
{
    CV_DIST_USER         = -1,
    CV_DIST_L1           = 1,
    CV_DIST_L2           = 2,
} CvDisType;

typedef struct CvMemBlock
{
    struct CvMemBlock*  prev;
    struct CvMemBlock*  next;
}
CvMemBlock;

struct CvSet;

typedef struct CvSparseMat
{
    struct CvSet* heap;
    void** hashtable;
    int size[CV_MAX_DIM];
} CvSparseMat;

typedef struct CvSet
{
    int       header_size;
    struct    CvSeq* h_prev;
} CvSet;

typedef struct CvPOSITObject CvPOSITObject;
