#! /usr/bin/env python

templatedict = {
    ('abcdefg', None): """\
        <STUB: abcdefg>""",

    ('forward', None): """\
        cdef <@StructUnionOrEnumSpecifier_token@> <@StructOrUnionBody_4@>:
            char lacking
        %s""",

    ('struct_def', 0): """\
        <@incomplete_types@>
        cdef <@Struct\"\"\"UnionOrEnumSpecifier_token@> <@TypedefStructLabel@>:
            <@s_u_e_decls@>""",

    ('struct_def', 1): """\
        <@incomplete_types@>
        cdef <@StructUnionOrEnumSpecifier_token@> <@StructOrUnionBody_0@>:
            <@s_u_e_decls@>
        ctypedef <@StructOrUnionBody_0@> <@Declarator_0@>""",

    ('struct_def', 2): """\
        <@incomplete_types@>
        ctypedef <@StructUnionOrEnumSpecifier_token@> <@Declarator_0@>:
            <@s_u_e_decls@>""",
}

class Creators(object):
    def __init__(self, Q):
        self.Q = Q
        self.templatedict = templatedict
        for pair in self.templatedict:
            self.templatedict[pair] = self.unindent(self.templatedict[pair])

    def unindent(self, text):
        lines = text.splitlines()
        minspaces = 1000
        for line in lines:
            spaces = len(line) - len(line.lstrip())
            minspaces = min(spaces, minspaces)
        if minspaces == 0:
            return text
        out = []
        for line in lines:
            out.append(line[minspaces:])
        return '\n'.join(out)

    def Forward(self, node):
        d0 = self.Q.Declarator_0()
        s1 = self.Q.StructOrUnionBody_4()
        if d0 == s1:
            return self.templatedict[('forward', None)] % ''
        return self.templatedict[('forward', None)] % \
            'ctypedef <@StructOrUnionBody_4@> <@Declarator_0@>'

    def Creator_struct_def(node):
        if self.Q.StructOrUnionBody_0() is not None:
            if self.Q.Declarator_0() == self.Q.StructOrUnionBody_0():
                return '<@struct_def1@>'
            else:
                return '<@struct_def2@>'
        else:
            return '<@struct_def3@>'

if __name__ == '__main__':
    import questioner, Tree
    Q = questioner.Questioner(Tree.Tree())
    C = Creators(Q)
    for key in C.templatedict:
        print key
        print C.templatedict[key]
        print
