#! /usr/bin/env python

class MethodWrapper(object):
    def __init__(self, method):
        self.method = method
    def __get__(self, instance, type=None):
    	result = wrapper(instance, self.method) 
    	setattr(instance, self.method.__name__, result)
        return result

class wrapper:

    def __init__(self, instance, method):
        self.counter = 0
        self.instance = instance
        self.method = method
        self.cache = dict()
   
    def __call__(self, arg):
        self.counter += 1
        if arg in self.cache:
            print 'arg =', arg, 'is cached for', self.method.__name__
            return self.cache[arg]
        else:
            result = self.method(self.instance, arg)
            self.cache[arg] = result
        return result

def test():
    class C:
        def MFfun1(self, node):
            return node+1
        MFfun1 = MethodWrapper(MFfun1)

        def MFfun2(self, node):
            return 3*node
        MFfun2 = MethodWrapper(MFfun2)

    c = C()
    print c.MFfun1(1)
    print c.MFfun1(7)
    print c.MFfun1(1)
    print c.MFfun2(3)
    print c.MFfun2(3)
    print c.MFfun1.counter, c.MFfun2.counter

if __name__=='__main__':
    test()
