#! /usr/bin/env python

class MethodWraper(object):
    def __init__(self, method):
        self.method = method
    def __get__(self, instance, type=None):
    	result = wrapper(instance, self.method) 
    	setattr(instance, self.method.__name__, result)
        return result

class wrapper:
    def __init__(self, instance, method):
        self.instance = instance
        self.method = method
        self.counter = 0
        self.cache = dict()
   
    def __call__(self, immutable, *args, **kargs):
        # Cannot cache without using all the args.
        if immutable in self.cache:
            ...
        self.counter += 1
        result = self.method(*((self.instance, immutable) + args), **kargs)
        return result

def test():
    class C:
        def f(self, num):
            return num+1
        f = MethodWraper(f)

        def g(self, num):
            return num+1
        g = MethodWraper(g)

    c = C()
    print 'f', c.f(1)
    print 'g', c.g(1)
    print 'f', c.f(7)
    print 'g', c.g(7)
    print 'f', c.f(1)
    print 'g', c.g(1)
    print c.f.counter
    print c.g.counter

if __name__=='__main__':
    test()
