include "tools.pyx"

cdef extern from "nested.h":

    cdef enum TemP__srdgh:
        CV_MAX_DIM = 40

    
    ctypedef union Overlap:
        int  i
        float  x

    
    ctypedef struct Nest:
        Overlap  overlap

cdef class TemP__Overlap:
    cdef Overlap* t

    def __new__(self, i, x):
        self.t = <Overlap*> PyMem_Malloc(sizeof(Overlap))
        if self.t == NULL:
            raise MemoryError
        cdef int LocaLi
        cdef int LocaLj
        self.t.i = i
        self.t.x = x

    def __dealloc__(self):
        PyMem_Free(self.t)

    def __getattr__(self, name):
        if name == 'i':
            return self.t.i
        if name == 'x':
            return self.t.x
        return object.__getattribute__(self, name)

    def __setattr(self, name, val):
        if name == 'i':
            self.t.i = val
        elif name == 'x':
            self.t.x = val
        else:
            object.__setattr__(self, name, val)

    def ToPointer(self):
        # BUG: Maybe need "stars" with one star removed.
        # See example5/test.py for usage.
        return  PyCObject_FromVoidPtrAndDesc(self.t, 'Overlap *', NULL)

cdef TemP__Overlap_ToC(TemP__PY, Overlap * TemP__ptr):
    TemP__ptr.i = TemP__PY.i
    TemP__ptr.x = TemP__PY.x

cdef TemP__Overlap_FromC(Overlap * TemP__ptr):
    TemP__PY0 = TemP__ptr.i
    TemP__PY1 = TemP__ptr.x
    return TemP__Overlap(TemP__PY0, TemP__PY1)

def TemP__Overlap_FromOpaquePointer(co):
    cdef Overlap* TemP__ptr
    TemP__ptr = <Overlap*> extract_ptr(co)
    return TemP__Overlap_FromC(TemP__ptr)

cdef class TemP__Nest:
    cdef Nest* t

    def __new__(self, overlap):
        self.t = <Nest*> PyMem_Malloc(sizeof(Nest))
        if self.t == NULL:
            raise MemoryError
        cdef int LocaLi
        cdef int LocaLj
        TemP__Overlap_ToC(overlap, &self.t.overlap)

    def __dealloc__(self):
        PyMem_Free(self.t)

    def __getattr__(self, name):
        if name == 'overlap':
            return TemP__Overlap_FromC(&self.t.overlap)
        return object.__getattribute__(self, name)

    def __setattr(self, name, val):
        if name == 'overlap':
            TemP__Overlap_ToC(val, &self.t.overlap)
        else:
            object.__setattr__(self, name, val)

    def ToPointer(self):
        # BUG: Maybe need "stars" with one star removed.
        # See example5/test.py for usage.
        return  PyCObject_FromVoidPtrAndDesc(self.t, 'Nest *', NULL)

cdef TemP__Nest_ToC(TemP__PY, Nest * TemP__ptr):
    TemP__Overlap_ToC(TemP__PY.overlap, &TemP__ptr.overlap)

cdef TemP__Nest_FromC(Nest * TemP__ptr):
    TemP__PY0 = TemP__Overlap_FromC(&TemP__ptr.overlap)
    return TemP__Nest(TemP__PY0)

def TemP__Nest_FromOpaquePointer(co):
    cdef Nest* TemP__ptr
    TemP__ptr = <Nest*> extract_ptr(co)
    return TemP__Nest_FromC(TemP__ptr)

