cdef extern from "example.h":
    ctypedef struct c_Example "Example":
        int iVal

    c_Example* create(int i)
    void destroy(c_Example* t)
    int c_mult "mult" (c_Example *t, int scalar, int shift)

cdef class Example:
    cdef c_Example* t

    def __new__(self, i):
        self.t = create(i)
        if self.t == NULL:
            raise MemoryError

    def __dealloc__(self):
        destroy(self.t)

    def mult(self, pair):
        return c_mult(self.t, pair[0], pair[1])

    def __getattr__(self, name):
        if name == 'iVal':
            return self.t.iVal
        return object.__getattribute__(self, name)

    def __setattr__(self, name, val):
        if name == 'iVal':
            self.t.iVal = val
        else:
            object.__setattr__(self, name, val)
