ctypedef int size_t

cdef extern from "stdlib.h":
    void* malloc(size_t size)
    void free(void* ptr)

cdef extern from "stdio.h":
    int printf(char* format, ...)

cdef extern from "Python.h":
    void* PyMem_Malloc(size_t n)
    void* PyMem_Realloc(void *p, size_t n)
    void PyMem_Free(void *p)
    # ...

cdef extern from "example.h":
    int* funct(int n)

def pyfunct(n):
    cdef int* arr

    arr = funct(n)
    out = []
    for i in range(n):
        out.append(arr[i])
    free(arr)
    return out

# This version exposes the conversions for Python to C or vice versa. They
# are "n = pyn" and "i = pyi"
def pyfunct2(object pyn):
    cdef int n
    cdef object pyi
    cdef int i
    cdef int* arr

    n = pyn
    arr = funct(n)
    out = []
    for pyi in range(pyn):
        i = pyi
        out.append(arr[i])
    free(arr)
    return out

# This version uses the Pyrex for loop construct. I personally prefer to
# stick to BASICs: "for i from 0 to n" or "for i from 0 to n step 2:".
def pyfunct3(object pyn):
    cdef int n
    cdef object pyi
    cdef int i
    cdef int* arr

    n = pyn
    arr = funct(n)
    out = []
    for i from 0 <= i < n:
        out.append(arr[i])
    free(arr)
    return out
